<script lang="ts">
import Vue from 'vue';
import HeroAnimation from '../assets/hero-animation.vue';

export default Vue.extend({
  name: 'AnimatedHero',
  components: {
    HeroAnimation,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <div ref="animated-hero" class="animated-hero" :class="data.variant">
    <SlpRow class="container__row">
      <SlpColumn :cols="6" class="animated-hero__text-column">
        <div v-if="data.note.text" class="animated-hero__wrapper">
          <SlpTypography
            variant="heading5"
            tag="p"
            class="animated-hero__note slp-mb-12 animated-hero__wrapper__content"
            :style="{ animationDuration: data.note?.animation_duration }"
            >{{ data.note.text }}</SlpTypography
          >
        </div>
        <div
          v-if="data.title.text"
          class="animated-hero__wrapper animated-hero__wrapper--wide"
        >
          <SlpTypography
            variant="heading1-bold"
            tag="h1"
            class="animated-hero__wrapper__content animated-hero__title slp-mb-16"
            :style="{ animationDuration: data.title?.animation_duration }"
            ><span v-html="data.title.text"></span
          ></SlpTypography>
        </div>
        <div v-if="data.description.text" class="animated-hero__wrapper">
          <SlpTypography
            variant="body1"
            tag="p"
            class="animated-hero__wrapper__content slp-mb-24"
            :style="{ animationDuration: data.description?.animation_duration }"
            ><span v-html="data.description.text"></span
          ></SlpTypography>
        </div>
        <div class="animated-hero__wrapper">
          <SlpButton
            variant="secondary"
            class="animated-hero__wrapper__content slp-mb-8 animated-hero__button"
            :data-ga-name="
              data.secondary_btn.data_ga_name || 'read the full survey'
            "
            :data-ga-location="data.secondary_btn.data_ga_location || 'hero'"
            :href="data.secondary_btn.url || '#download'"
            :style="{
              animationDuration: data.secondary_btn?.animation_duration,
            }"
            >{{ data.secondary_btn.text }}
            <SlpIcon
              class="slp-ml-8"
              name="arrow-down"
              variant="product"
              size="sm"
              slp-color="$color-primary-300"
            />
          </SlpButton>
        </div>
      </SlpColumn>
      <SlpColumn :cols="6" class="animated-hero__image-column">
        <HeroAnimation />
      </SlpColumn>
    </SlpRow>
  </div>
</template>

<style lang="scss" scoped>
.animated-hero {
  color: $color-primary-300;
  &__title {
    width: 100%;
    @media (max-width: $breakpoint-sm) {
      * {
        font-size: $spacing-64;
        line-height: 1;
      }
    }
    @media (min-width: $breakpoint-md) {
      width: 130%;
    }
    span {
      opacity: 0;
      animation: opacity-intro 0.9s linear forwards 1.2s;
    }
  }
  &__image-column {
    width: 100%;
    padding: $spacing-160 0 40% 0;
    @media (min-width: $breakpoint-sm) {
      padding: $spacing-160 0 16% 0;
    }
  }
  &__text-column {
    position: relative;
    z-index: 1;
    @media (min-width: $breakpoint-lg) {
      padding-top: $spacing-160;
    }
  }
  &__note {
    font-family: 'GitLab Mono';
    color: #5dd7b1;
  }
  &__wrapper {
    overflow-y: clip;
    &.animated-hero__wrapper--wide {
      overflow: visible;
      @media (min-width: $breakpoint-md) {
        width: 130%;
      }
    }

    &__content {
      animation-name: intro-reveal;
      animation-fill-mode: forwards;
      animation-delay: 0.9s;
      transform: translate3d(0, 150%, 0);
      will-change: transform;
      @media (prefers-reduced-motion) {
        animation: none;
        transform: none !important;
      }
    }
  }
  @keyframes intro-reveal {
    from {
      transform: translate3d(0, 150%, 0);
    }
    to {
      transform: translate3d(0, 0%, 0);
    }
  }

  @keyframes opacity-intro {
    from {
      opacity: 0;
    }
    to {
      opacity: 1;
    }
  }
}
</style>
